/*
		Master Chess v 1.0 - String Generator Interface for Arduino

		Copyright (C) 2012 Ponto Crítico Engineering - pontocriticoengieering.wordpress.com
		Gabriel Herman Bernardim Andrade, Gustavo Ribeiro Siqueira, Luís Felipe Nogoseke

		email:	ponto.critico@live.com
		
		This programm is free software; you can redistribute it and/or
		modify it under the terms of the GNU General Public License as
		published by the Free Software Foundation; either version 2 of
		the License, or (at your option) any later version.
		
		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
		General Public License for more details.
		
		You should have received a copy of the GNU General Public License
		along with this program; if not, write to the Free Software
		Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


*/



#include <Stepper.h>
#include <LiquidCrystal.h>



const int stepsPerSquare = 80;
char data[34]; //buffer para a leitura serial
int linha[32] = {0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 8, 8, 9, 9, 9, 9, 9, 9, 9, 9};  //posicoes para as pecas mortas
int coluna[32] = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 8, 9, 8, 9, 8 ,9, 8, 9, 8, 9, 8, 9, 8, 9, 7, 6, 5, 4, 3, 2, 1};
int aux;

int c, l, c1, l1, C, L, C1, L1; //variaveis para as coordenadas das posicoes
int q;  
char b, n; //variaveis para tipo de jogada
int j; //numero de jogadas
char w = 'i'; //variavel para os cases
char x, m, M; //variaveis para o teste de fim de jogo e para jogadas de captura


//inicializando os pinos do LCD e dos motores
LiquidCrystal lcd(32, 34, 48, 46, 44, 42);
Stepper stepper2(48, 6,8,7,9);            
Stepper stepper1(48, 2,4,3,5);

int eletroima = 12;


void setup() {
  stepper1.setSpeed(60);
  stepper2.setSpeed(60);
  
  lcd.begin(16, 2);
  
  pinMode(eletroima, OUTPUT);
  
  Serial.begin(9600);
  Serial.flush();
}


//exemplo de jogada e2e4, e7e5;v2;4;4;4;n;v7;4;5;4;n;u
//c2f5, g7f5;d2;2;5;5;n;c7;6;5;5;m;u

void loop() {
  
  switch (w){
    //apresentacao e escolha das pecas
    case 'i':
      //linha[32] = {0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 8, 8, 9, 9, 9, 9, 9, 9, 9, 9};
      //coluna[32] = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 8, 9, 8, 9, 8 ,9, 8, 9, 8, 9, 8, 9, 8, 9, 7, 6, 5, 4, 3, 2, 1};
      j = 1;
      intro();
      w = '0';
    break;  
   
   //limpa o buffer, testa se ha dados na entrada serial, chama funcao para ler os dados, e a funcao para escrever no LCD
   case '0':
      Serial.flush();
        for(int a=0; a<34; a++)
          data[a]='\0';
        
        
        if (Serial.available()>0){
          int index = 0;
          aux=0;
          delay(100);
          aux= Serial.available();
          while(aux--){
            data[index++]=Serial.read();
          }
          splitString(data, &c, &l, &c1, &l1, &b, &C, &L, &C1, &L1, &n);
          jogada(&j, data);
          
          //testa se ha uma captura
          if(m == 'm')
            matar(c1, l1);
           //movimento das brancas
          mover(b, c, l, c1,l1);
          
          //testa se ha uma captura
          if(M == 'm')
            matar(C1, L1);
            
            //movimento das negras
          mover(n, C, L, C1, L1);
          Serial.println("Fim da Jogada");
          if(x != 'u'){
             w = x; 
          }
        }
         
    break;
    
    
    //cases de fim de jogo
    case 'b':
      lcd.setCursor(0,1);
      lcd.print("VITORIA DAS BRANCAS");
      w = 'i';
    break;
      
    case 'n':
      lcd.setCursor(0,1);
      lcd.print("VITORIA DAS NEGRAS");
      w = 'i';
    break;
    
    case 'e':
      lcd.setCursor(0,1);
      lcd.print("EMPATE");
      w = 'i';
    break;
           
    default:
    w = '0';
  }

}

//funcao que separa os dados da leitura serial
void splitString(char* d, int* v, int* h, int* v1, int* h1, char* f, int* V, int* H, int* V1, int* H1, char* n){
   Serial.println(d);
   char* parameter;
   parameter = strtok (d, ";");
   Serial.println(parameter); //jogada para ser mostrada no LCD
   
   parameter = strtok(NULL, ";");
   Serial.println(parameter); //tipo do movimento e coordenada vertical
   
   *f= char(parameter[0]);
   Serial.println(w); //tipo da jogada
   *v = strtol(parameter+1, NULL, 10);
   Serial.println(*v);// coordenada coluna
   
   parameter = strtok(NULL, ";");
   *h  = strtol(parameter, NULL, 10);
   Serial.println(*h);// coordenada linha
   
   parameter = strtok(NULL, ";");
   *v1  = strtol(parameter, NULL, 10);
   Serial.println(*v1);// coordenada vertical
   
   parameter = strtok(NULL, ";");
   *h1  = strtol(parameter, NULL, 10);
   Serial.println(*h1);// coordenada horizontal
   
   parameter = strtok(NULL, ";");
   m = char(parameter[0]);
   
   
   
   parameter = strtok(NULL, ";");
   Serial.println(parameter); //tipo do movimento e coordenada vertical
   
   *n= char(parameter[0]);
   Serial.println(w); //tipo da jogada
   *V = strtol(parameter+1, NULL, 10);
   Serial.println(*v);// coordenada vertical
   
   parameter = strtok(NULL, ";");
   *H  = strtol(parameter, NULL, 10);
   Serial.println(*h);// coordenada horizontal
   
   parameter = strtok(NULL, ";");
   *V1  = strtol(parameter, NULL, 10);
   Serial.println(*v1);// coordenada vertical das negras
   
   parameter = strtok(NULL, ";");
   *H1  = strtol(parameter, NULL, 10);
   Serial.println(*h1);// coordenada horizontal
   
   parameter = strtok(NULL, ";");
   M = char(parameter[0]);
   
   
   parameter = strtok(NULL, ";");
   x = char(parameter[0]);
   
   
   Serial.println(x);// fim de jogo?
   
}


//funcao de introducao
void intro(){
  lcd.setCursor(2,2);
        lcd.print("Master Chess");
        lcd.setCursor(0,0);
        lcd.print("================");
        delay(3000);
}

//funcao para mostrar as jogadas no LCD
void jogada(int* i, char* s){
  lcd.clear();
  lcd.print(*i);
  lcd.print(".");
  lcd.print(s);
  *i +=1;
}

//funcao para ir ate onde esta a peca

void ir(int v, int h){
  Serial.println("indo");
  stepper1.step((v*stepsPerSquare));
  stepper2.step((h*stepsPerSquare));
  
}

//funcao para retornar o eletroima a posicao inicial
void voltar(int v, int h){
  Serial.println("voltando");
  v = -(v*stepsPerSquare);
  h = -(h*stepsPerSquare);
  stepper1.step(v);
  stepper2.step(h);
}

//funcao para mover a peca
void mover(char z,int v, int h, int v1, int h1){
  ir(v, h);
  digitalWrite(eletroima, HIGH);
  delay(1000);
   switch (z){
      case 'v':
        Serial.println("movimento v");
        Serial.println(stepsPerSquare*(h1-h));
        stepper1.step((stepsPerSquare*(v1-v)));
        stepper2.step((stepsPerSquare*(h1-h)));
      
      break;
      
      case 'c':
        Serial.println("movimento c");   
        if(abs(v1-v)>abs(h1-h)){
           stepper2.step((stepsPerSquare/2)*(h1-h));
           stepper1.step((stepsPerSquare*(v1-v)));
           stepper2.step((stepsPerSquare/2)*(h1-h));
        }
        else{
           stepper1.step((stepsPerSquare/2)*(v1-v));
           stepper2.step((stepsPerSquare*(h1-h)));
           stepper1.step((stepsPerSquare/2)*(v1-v));
        }
             
        break;
      
       case 'r':
        Serial.println("roque pequeno");
        if(v==1){
        stepper2.step(stepsPerSquare*2);
        digitalWrite(eletroima, LOW);
        delay(1000);
        stepper2.step(stepsPerSquare);
        digitalWrite(eletroima, HIGH);
        delay(1000);
        stepper1.step(-stepsPerSquare);
        stepper2.step(-stepsPerSquare*2);
        stepper1.step(stepsPerSquare);
        digitalWrite(eletroima, LOW);
        delay(1000);
        stepper2.step(stepsPerSquare);
        }
         else{
        stepper2.step(-stepsPerSquare*2);
        digitalWrite(eletroima, LOW);
        delay(1000);
        stepper2.step(-stepsPerSquare);
        digitalWrite(eletroima, HIGH);
        delay(1000);
        stepper1.step(stepsPerSquare);
        stepper2.step(stepsPerSquare*2);
        stepper1.step(-stepsPerSquare);
        digitalWrite(eletroima, LOW);
        delay(1000);
        stepper2.step(-stepsPerSquare);
        }
         break;
         
         case 'R':
           Serial.println("roque grande");
          stepper2.step(stepsPerSquare*(h1-h));
          digitalWrite(eletroima, LOW);
          stepper2.step(stepsPerSquare*2);
          digitalWrite(eletroima, HIGH);
          stepper1.step(stepsPerSquare/2);
          stepper2.step(-stepsPerSquare*3);
          stepper1.step(-stepsPerSquare/2);
          digitalWrite(eletroima, LOW);
          stepper2.step(stepsPerSquare);
         break;
      
      
      case 'd':
        Serial.println("movimento d");
        int s1 = ((v1-v)/abs(v1-v));
        int s2 = ((h1-h)/abs(h1-h));
        int z = stepsPerSquare*abs(v1-v);
        Serial.print(z);
        Serial.println(s1);
        Serial.println(s2);
        for(int i =0; i<z; i++){
           stepper1.step(s1);
           stepper2.step(s2);
           Serial.println(i);
        }
               
      break;
      
    /*  case 'r':
        Serial.println("roque pequeno");
        stepper1.step(stepsPerSquare*(v1-v));
        digitalWrite(eletroima, LOW);
        stepper1.step(stepsPerSquare);
        digitalWrite(eletroima, HIGH);
        stepper2.step(stepsPerSquare/2);
        stepper1.step(-stepsPerSquare*2);
        stepper2.step(-stepsPerSquare/2);
        digitalWrite(eletroima, LOW);
        stepper1.step(stepsPerSquare);
         break;  */   
   }
  digitalWrite(eletroima, LOW);
  delay(1000);
  voltar(v1, h1); 
}

void matar(int l, int c){
  Serial.println("matando");
   ir(l, c);
   digitalWrite(eletroima, HIGH);
   int i =0;
   while((linha[i] && coluna[i])== 89){
     i++;
   }
   int s = ((coluna[i]-c)/abs(coluna[i]-c));
   
   stepper1.step(((stepsPerSquare/2)*s));
   stepper2.step((stepsPerSquare*(linha[i]-l)));
   stepper1.step(stepsPerSquare*(coluna[i]-c));
   stepper1.step(((stepsPerSquare/2)*(-s)));
   digitalWrite(eletroima, LOW);
   voltar(linha[i], coluna[i]);
   linha[i] =89;
   coluna[i] = 89;
   
}
