package rxtx;

import gnu.io.CommPortIdentifier;

import gnu.io.SerialPort;

import gnu.io.SerialPortEvent;

import gnu.io.SerialPortEventListener;

import java.io.IOException;

import java.io.InputStream;

import java.io.OutputStream;

import java.sql.ResultSet;

import java.util.ArrayList;

import java.util.Iterator;

public class SComm implements Runnable, SerialPortEventListener {


public String Dadoslidos;
public int nodeBytes;
public int baudrate;
public int timeout;
public CommPortIdentifier cp;
public SerialPort porta;
public OutputStream saida;
public InputStream entrada;
public Thread threadLeitura;
public boolean IDPortaOK;
public boolean PortaOK;
public boolean Leitura;
public boolean Escrita;
public String Porta;
public String peso;


public void setPeso(String peso){
        this.peso = peso;
}

public String getPeso(){
        return peso;
}

 
public SComm(){
        this.Porta = "/dev/ttyACM0";
        this.baudrate = 9600;
        this.timeout = 200;
}

 
public void HabilitarEscrita(){

        Escrita = true;
        Leitura = false;
}

   
public void HabilitarLeitura(){

        Escrita = false;
        Leitura = true;
}

 
public void ObterIdDaPorta(){

        try {

            cp = CommPortIdentifier.getPortIdentifier(Porta);
            
            if ( cp == null ) {
                System.out.println("Erro na porta");
                IDPortaOK = false;
                System.exit(1);
            }

            IDPortaOK = true;

        } catch (Exception e) {
            System.out.println("Erro obtendo ID da porta: " + e);
            IDPortaOK = false;
            System.exit(1);
        }
}
 

public void AbrirPorta(){

        try {

            porta = (SerialPort)cp.open("SerialComLeitura", timeout);
            PortaOK = true;
            //configurar parâmetros
            porta.setSerialPortParams(baudrate,
            						  porta.DATABITS_8,
            						  porta.STOPBITS_1,
            						  porta.PARITY_NONE);
           
            porta.setFlowControlMode(SerialPort.FLOWCONTROL_NONE);
            //Thread.sleep(1500);
            
        }catch(Exception e){

            PortaOK = false;
            System.out.println("Erro abrindo comunicação: "  + e);
            System.exit(1);
        }
}


public void LerDados(){

        if (Escrita == false){
            try {
                entrada = porta.getInputStream();

            } catch (Exception e) {
                System.out.println("Erro de stream: " + e);
                System.exit(1);
            }

            try {
            	porta.addEventListener(this);

            } catch (Exception e) {
                System.out.println("Erro de listener: " + e);
                System.exit(1);
            }

            porta.notifyOnDataAvailable(true);

            try {
                threadLeitura = new Thread(this);
                threadLeitura.start();
                run();

            } catch (Exception e) {
                System.out.println("Erro de Thred: " + e);
            }
        }
}
 

public void EnviarUmaString(String msg){

        if (Escrita==true) {
            try {
                saida = porta.getOutputStream();
                System.out.println("FLUXO OK!");

            } catch (Exception e) {
                System.out.println("Erro.STATUS: " + e );
            }

            try {
                System.out.println("Enviando um byte para " + Porta );
                System.out.println("Enviando : " + msg );
                byte[] a = msg.getBytes();
                Thread.sleep(2500);
                saida.write(a);
                Thread.sleep(7500);
                saida.flush();

            } catch (Exception e) {
                System.out.println("Houve um erro durante o envio. ");
                System.out.println("STATUS: " + e );
                System.exit(1);
            }
            
        } else {
            System.exit(1);
        }
}

 



 

public void run(){

        try {

            Thread.sleep(5);

        } catch (Exception e) {

            System.out.println("Erro de Thred: " + e);

        }

}

 




 

public void serialEvent(SerialPortEvent ev){       

        StringBuffer bufferLeitura = new StringBuffer();

        int novoDado = 0;

       

        if (ev.getEventType() == SerialPortEvent.DATA_AVAILABLE) {


                //Novo algoritmo de leitura.

                while(novoDado != -1){

                    try{
                    	int available = entrada.available();
        				byte chunk[] = new byte[available];
                    	
                        novoDado = entrada.read(chunk, 0, available) ;

                        if(novoDado == -1){

                            break;

                        }

                        if('\r' == (char)novoDado){

                            bufferLeitura.append('\n');

                        }else{
                            bufferLeitura.append((char)novoDado);
                        }

                    }catch(IOException ioe){
                        System.out.println("Erro de leitura serial: " + ioe);
                    }
                }

              System.out.println(new String(bufferLeitura));
            

        }

}

 



 

public void FecharCom(){

            try {

                porta.close();

            } catch (Exception e) {

                System.out.println("Erro fechando porta: " + e);

                System.exit(0);

            }

}

   

public String obterPorta(){

        return Porta;

}

   

public int obterBaudrate(){

        return baudrate;

    }

}

 



 




